<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LoggerServiceImpl.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">vendingmachine</a> &gt; <a href="index.source.html" class="el_package">com.example.vendingmachine.log</a> &gt; <span class="el_source">LoggerServiceImpl.java</span></div><h1>LoggerServiceImpl.java</h1><pre class="source lang-java linenums">package com.example.vendingmachine.log;

import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import org.springframework.stereotype.Service;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.java.Log;

@Service
<span class="fc" id="L15">@Log</span>
<span class="fc" id="L16">public class LoggerServiceImpl implements LoggerService {</span>

    @Override
    public void logRequest(HttpServletRequest httpServletRequest, Object body) {
<span class="nc" id="L20">        StringBuilder stringBuilder = new StringBuilder();</span>
<span class="nc" id="L21">        Map&lt;String, String&gt; parameters = buildParametersMap(httpServletRequest);</span>

<span class="nc" id="L23">        stringBuilder.append(&quot;REQUEST &quot;);</span>
<span class="nc" id="L24">        stringBuilder.append(&quot;method=[&quot;).append(httpServletRequest.getMethod()).append(&quot;] &quot;);</span>
<span class="nc" id="L25">        stringBuilder.append(&quot;path=[&quot;).append(httpServletRequest.getRequestURI()).append(&quot;] &quot;);</span>
<span class="nc" id="L26">        stringBuilder.append(&quot;headers=[&quot;).append(buildHeadersMap(httpServletRequest)).append(&quot;] &quot;);</span>

<span class="nc bnc" id="L28" title="All 2 branches missed.">        if (!parameters.isEmpty()) {</span>
<span class="nc" id="L29">            stringBuilder.append(&quot;parameters=[&quot;).append(parameters).append(&quot;] &quot;);</span>
        }

<span class="nc bnc" id="L32" title="All 2 branches missed.">        if (body != null) {</span>
<span class="nc" id="L33">            stringBuilder.append(&quot;body=[&quot; + body + &quot;]&quot;);</span>
        }

<span class="nc" id="L36">        log.info(stringBuilder.toString());</span>
<span class="nc" id="L37">    }</span>

    @Override
    public void logResponse(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse,
            Object body) {
<span class="nc" id="L42">        StringBuilder stringBuilder = new StringBuilder();</span>

<span class="nc" id="L44">        stringBuilder.append(&quot;RESPONSE &quot;);</span>
<span class="nc" id="L45">        stringBuilder.append(&quot;method=[&quot;).append(httpServletRequest.getMethod()).append(&quot;] &quot;);</span>
<span class="nc" id="L46">        stringBuilder.append(&quot;path=[&quot;).append(httpServletRequest.getRequestURI()).append(&quot;] &quot;);</span>
<span class="nc" id="L47">        stringBuilder.append(&quot;responseHeaders=[&quot;).append(buildHeadersMap(httpServletResponse)).append(&quot;] &quot;);</span>
<span class="nc" id="L48">        stringBuilder.append(&quot;responseBody=[&quot;).append(body).append(&quot;] &quot;);</span>

<span class="nc" id="L50">        log.info(stringBuilder.toString());</span>
<span class="nc" id="L51">    }</span>

    private Map&lt;String, String&gt; buildParametersMap(HttpServletRequest httpServletRequest) {
<span class="nc" id="L54">        Map&lt;String, String&gt; resultMap = new HashMap&lt;&gt;();</span>
<span class="nc" id="L55">        Enumeration&lt;String&gt; parameterNames = httpServletRequest.getParameterNames();</span>

<span class="nc bnc" id="L57" title="All 2 branches missed.">        while (parameterNames.hasMoreElements()) {</span>
<span class="nc" id="L58">            String key = parameterNames.nextElement();</span>
<span class="nc" id="L59">            String value = httpServletRequest.getParameter(key);</span>
<span class="nc" id="L60">            resultMap.put(key, value);</span>
<span class="nc" id="L61">        }</span>

<span class="nc" id="L63">        return resultMap;</span>
    }

    private Map&lt;String, String&gt; buildHeadersMap(HttpServletRequest request) {
<span class="nc" id="L67">        Map&lt;String, String&gt; map = new HashMap&lt;&gt;();</span>

<span class="nc" id="L69">        Enumeration headerNames = request.getHeaderNames();</span>
<span class="nc bnc" id="L70" title="All 2 branches missed.">        while (headerNames.hasMoreElements()) {</span>
<span class="nc" id="L71">            String key = (String) headerNames.nextElement();</span>
<span class="nc" id="L72">            String value = request.getHeader(key);</span>
<span class="nc" id="L73">            map.put(key, value);</span>
<span class="nc" id="L74">        }</span>

<span class="nc" id="L76">        return map;</span>
    }

    private Map&lt;String, String&gt; buildHeadersMap(HttpServletResponse response) {
<span class="nc" id="L80">        Map&lt;String, String&gt; map = new HashMap&lt;&gt;();</span>

<span class="nc" id="L82">        Collection&lt;String&gt; headerNames = response.getHeaderNames();</span>
<span class="nc bnc" id="L83" title="All 2 branches missed.">        for (String header : headerNames) {</span>
<span class="nc" id="L84">            map.put(header, response.getHeader(header));</span>
<span class="nc" id="L85">        }</span>

<span class="nc" id="L87">        return map;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>